package csci1902.hw3;

import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

public class WasteTransportAnt extends Ant {
	public Point position;
	int maximumWaste;
	int wasteCarry;
	int wasteCarryNext;
	World world;
	public WasteTransportAnt(int maxWaste, World worldo, Point pos){
		super(worldo, pos);
		position = pos;
		maximumWaste=maxWaste;
		world=worldo;
		wasteCarry=0;
		wasteCarryNext=0;
	}
	public int getWasteUnits(){
		return wasteCarry;
	}
	public void act(List<Entity> neighbors){
		Point currentPosition=getPosition();
		List<Point> neighborPoints = new ArrayList<Point>();
		neighborPoints=world.getNeighboringCells(currentPosition);
		double best=6.0;
		Point bestPoint=new Point();
		if (wasteCarry==0){
			for(int i=0;i<neighbors.size();i++){
				if(neighbors.get(i).isWasteSource()==true){
					wasteCarryNext=neighbors.get(i).collectWaste(maximumWaste);
					return;
				}
			}
		}
		if (wasteCarry != 0){
			for(int i=0;i<neighbors.size();i++){
				if(neighbors.get(i).isWasteSink()==true){
					neighbors.get(i).depositWaste(wasteCarry);
					wasteCarryNext=0;
					return;
				}
			}
		}
		if(wasteCarry != 0){
			for(int i=0;i<neighborPoints.size();i++){
				if(world.getWastePheromone(neighborPoints.get(i).x, neighborPoints.get(i).y)
					<best&&world.getWastePheromone(neighborPoints.get(i).x, neighborPoints.get(i).y)
						>=.1){
					best=world.getWastePheromone(neighborPoints.get(i).x, neighborPoints.get(i).y);
					bestPoint=neighborPoints.get(i);
				}
			}
			if(best<6){
				setNextPosition(bestPoint);
				return;
			}
			moveRandomly();
			return;
		}
		if (wasteCarry==0){
		world.depositWastePheromone(currentPosition.x, currentPosition.y, 5.0);
			goTowardsHome();
			return;
			}
	}

	public void update(){
		super.update();
		wasteCarry=wasteCarryNext;
		return;
	}
}